/*********************************************************************
*  PIC32MX+$B%?%V%l%C%H!!%*%7%m%9%3!<%W%W%m%0%i%`(B
*  $B0lDj4V3V$N%3%^%s%I<u?.$G%G!<%?<}=8!!(B2000$B%5%s%W%k(B
 * UART$B$G0l3gAw?.$7(BBluetooth$B$GL5@~Aw?.(B
*********************************************************************/
#include <xc.h>
//#include <plib.h>       		/* PIC32 peripheral library */

// $B%3%s%U%#%.%e%l!<%7%g%s@_Dj(B
// DEVCFG3
// USERID = No Setting
#pragma config PMDL1WAY = ON            // Peripheral Module Disable Configuration (Allow only one reconfiguration)
#pragma config IOL1WAY = OFF            // Peripheral Pin Select Configuration (Allow multiple reconfigurations)
#pragma config FUSBIDIO = OFF           // USB USID Selection (Controlled by Port Function)
#pragma config FVBUSONIO = OFF          // USB VBUS ON Selection (Controlled by Port Function)

// DEVCFG2
#pragma config FPLLIDIV = DIV_12        // PLL Input Divider (12x Divider) 48MHz/12=4MHz
#pragma config FPLLMUL = MUL_20         // PLL Multiplier (20x Multiplier) 4MHzx20=80MHz
#pragma config UPLLIDIV = DIV_12        // USB PLL Input Divider (12x Divider)
#pragma config UPLLEN = OFF             // USB PLL Enable (Disabled and Bypassed)
#pragma config FPLLODIV = DIV_2         // System PLL Output Clock Divider (PLL Divide by 2) 80MHz/2=40MHz

// DEVCFG1
#pragma config FNOSC = PRIPLL           // Oscillator Selection Bits (Primary Osc w/PLL (XT+,HS+,EC+PLL))
#pragma config FSOSCEN = OFF            // Secondary Oscillator Enable (Disabled)
#pragma config IESO = OFF               // Internal/External Switch Over (Disabled)
#pragma config POSCMOD = EC             // Primary Oscillator Configuration (External clock mode)
#pragma config OSCIOFNC = OFF           // CLKO Output Signal Active on the OSCO Pin (Enabled)
#pragma config FPBDIV = DIV_1           // Peripheral Clock Divisor (Pb_Clk is Sys_Clk/1) 40MHz
#pragma config FCKSM = CSDCMD           // Clock Switching and Monitor Selection (Clock Switch Disable, FSCM Disabled)
#pragma config WDTPS = PS1048576        // Watchdog Timer Postscaler (1:1048576)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable (Watchdog Timer is in Non-Window Mode)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable (WDT Disabled (SWDTEN Bit Controls))
#pragma config FWDTWINSZ = WISZ_25      // Watchdog Timer Window Size (Window Size is 25%)

// DEVCFG0
#pragma config JTAGEN = OFF             // JTAG Enable (JTAG Disabled)
#pragma config ICESEL = ICS_PGx1        // ICE/ICD Comm Channel Select (Communicate on PGEC1/PGED1)
#pragma config PWP = OFF                // Program Flash Write Protect (Disable)
#pragma config BWP = OFF                // Boot Flash Write Protect bit (Protection Disabled)
#pragma config CP = OFF                 // Code Protect (Protection Disabled)

/* $B%0%m!<%P%kJQ?tDj5A(B */
#define Fosc  57
#define Baud 115200
unsigned short Counter, Flag, BusyFlag, Index;
/* $BAw<u?.%P%C%U%!(B */
#define  Max_Size 4100
unsigned char RcvBuf[64];
unsigned char SndBuf[Max_Size];
/* $B%"%J%m%07WB,%G!<%?3JG<MQ%P%C%U%!(B */
unsigned short Buffer[2000];
unsigned char RcvData;
/* Bluetooth$B@_DjMQ%3%^%s%I%G!<%?(B */
unsigned char msg1[] = "$$$";                   // $B%3%^%s%I%b!<%I;XDj(B
unsigned char msg2[] = "SF,1\r";                // $B9)>l=P2Y%j%;%C%H(B
unsigned char msg3[] = "SN,PIC32Oscillo\r";     // $BL>>N@_Dj(B
unsigned char msg4[] = "R,1\r";                 // $B:F5/F0(B
/* $BCY1d4X?t$N%W%m%H%?%$%W(B */
void delay_us(unsigned int usec);
void Delayms(unsigned int msec);
void Send(unsigned char Data);
void SendData(unsigned char * buf);
void SendCmd(unsigned char *cmd);
void Hsync(unsigned char num);

/******* $B%a%$%s%k!<%A%s(B ***********/
int main(void)
{
    /* I/O$B@_Dj(B */
    ANSELA = 0x0003;                            // AN0,AN1$B$N$_%"%J%m%0(B
    ANSELB = 0;                                 // $B$9$Y$F%G%8%?%k(B
    TRISA = 0x0003;                             // AN0,1$B$N$_F~NO(B
    LATB  = 0x00000100;                         // $B=i4|%j%;%C%H(B
    TRISB = 0x00004100;                         // RX$B!"(BRB14$B$N$_F~NO(B
    CNPUBbits.CNPUB14 = 1;                      // RB14$B%W%k%"%C%WM-8z2=(B
    /** Bluetooth$B%b%8%e!<%k%j%;%C%H(B */
    LATBbits.LATB15 = 0;                        // $B%b%8%e!<%k%j%;%C%H(B
    Delayms(100);                               // $B%Q%k%9I}3NJ](B
    LATBbits.LATB15 = 1;                        // $B%j%;%C%H2r=|(B
    Delayms(1000);                              // $B<B9TBT$A(B
    /* UART$B%T%s%"%5%$%s(B */
    U2RXRbits.U2RXR = 4;                        // UART1 RX to RB8
    RPB9Rbits.RPB9R = 2;                        // UART1 TX to RB9
    /* UART$B$N=i4|@_Dj(B */
    U2MODE = 0x00008800;                        // $BC1=c!!HsF14|(B
    U2STA  = 0x0000D400;                        // $B<u?.$N$_Kh2s3d$j9~$_(B
    U2BRG  = (unsigned int)(2500000/Baud)-1;    // 115.2kbps
    /** Bluetooth$B%b%8%e!<%k=i4|2=(B */
    if(PORTBbits.RB14 == 0){                    // RB14$B$,(BLow$B$N>l9g$N$_(B
        SendCmd(msg1);                          // $$$
        SendCmd(msg2);                          // $B9)>l%j%;%C%H(B
        SendCmd(msg3);                          // $BL>>N@_Dj(B
        SendCmd(msg4);                          // $B%j%V!<%H(B
        /** USART $B:F@_Dj(B*/
        U2MODE = 0x00008800;                    // $BC1=cHsF14|(B
        U2STA  = 0x0000D400;                    // $B<u?.$N$_Kh2s3d$j9~$_(B
    }
    /* $B%?%$%^#3@_Dj!J(BA/D$BJQ49%H%j%,MQ!K(B */
    PR3 = 39;                                   // $B:GB.(B40MHz/40 = 1usec
    T3CON = 0x0000;                             // Off 1:1 FPB
    /* Setup ADC */
    AD1CON1 = 0x8044;                           // AD$B%*%s(B,$B@0?t(B16bit,$B%?%$%^#3$G%H%j%,(B
    AD1CON2 = 0x001E;                           // AVdd, AVss, 8$B2s$4$H3d9~$_(B,$B%P%C%U%!(B2$BJ,3d(B
    AD1CON3 = 0x0600;                           // 6Tad auto-sample, Tad = 2*Tcy= 50nsec
    AD1CHS  = 0;                                // AN0$BA*Br(B
    AD1CSSL = 0;                                // $B<+F0%9%-%c%s$J$7(B
    IPC5bits.AD1IP = 6;                         // $B3d$j9~$_%l%Y%k:G9b0L(B
    IFS0bits.AD1IF = 0;                         // $B3d$j9~$_%U%i%0%/%j%"(B
    Flag = 0;                                   // $BAw?.5v2D%U%i%0%;%C%H(B
    Index = 0;                                  // $B%P%C%U%!%$%s%G%C%/%9%j%;%C%H(B
    /* $B%^%k%A%Y%/%?3d$j9~$_@_Dj!"3d$j9~$_5v2D(B */
    IEC0bits.AD1IE = 1;                         // ADC$B3d$j9~$_5v2D(B
    IPC9bits.U2IP = 4;                          // UART2$B3d$j9~$_%l%Y%k(B4
    IEC1bits.U2RXIE = 1;                        // RX2$B3d$j9~$_5v2D(B
    INTEnableSystemMultiVectoredInt();          // $B%^%k%A%Y%/%?3d$j9~$_%;%C%H!"3d$j9~$_5v2D(B
    
    /*************** $B%a%$%s%k!<%W!!(B*****************/
    while(1){
       unsigned short i;
       /* $B<u?.%3%^%s%I=hM}(B */
        if((Flag == 1) && (RcvBuf[0] == 'S')) {         // $B<u?.40N;$7J8;z(BS$B$r<u?.$7$?>l9g(B 
            Flag = 0;                                   // $B<u?.40N;%U%i%0%/%j%"(B
            /* $B<u?.%G!<%?=hM}(B  */
            switch(RcvBuf[1]){                          // $B<u?.%G!<%?$GJ,4t(B
                case 'T':  /** $B%G!<%?7WB,3+;O%H%j%,$N>l9g(B ***/
                    /* $B%5%s%W%j%s%0<~4|@_Dj$H%G!<%?Aw?.(B */
                    T3CONbits.TON = 0;                  // $B%?%$%^#3$$$C$?$sDd;_(B
                    TMR3 = 0;                           // $B%?%$%^(B3$B%j%;%C%H(B
                    AD1CON1 = 0;                        // AD$B$$$C$?$s%*%U(B
                    Hsync(RcvBuf[2]);                   // $B%5%s%W%k<~4|@_Dj(B
                    Index = 0;                          // $B%P%C%U%!%$%s%G%C%/%9=i4|2=(B
                    if(RcvBuf[3] == 0)                  // $B%A%c%M%k@ZBX(B
                        AD1CHS = 0;                     // AN0$B;XDj(B
                    else
                        AD1CHS = 0x00010000;            // AN1$B;XDj(B
                    AD1CON1 = 0x8044;                   // AD$B%*%s(B,$B@0?t(B,$B%?%$%^#3$G%H%j%,(B
                    BusyFlag = 1;                       // $B%G!<%?<}=8Cf%U%i%0%*%s(B
                    T3CONbits.TON = 1;                  // $B%?%$%^#33+;O!"%5%s%W%j%s%03+;O(B
                    /*** 2000$B2s%5%s%W%j%s%0=*N;BT$A(B ***/
                    while(BusyFlag == 1);               // $B%G!<%?<}=840N;BT$A(B
                    /* $B<}=840N;!"%G!<%?Aw?.<B9T(B */
                    SndBuf[0] = 0x4D;                   // M$B%;%C%H(B
                    SndBuf[1] = 0x4E;                   // N$B%;%C%H(B
                    for(i=0; i<2000; i++){              // 2000$B8D$N%G!<%?$r%P%$%H$KJQ49(B
                       SndBuf[2*i+2] = Buffer[i] % 256; // $B2<0L%P%$%H(B
                       SndBuf[2*i+3] = Buffer[i] / 256; // $B>e0L%P%$%H(B
                    }
                    SndBuf[4002] = 'E';                 // $B=*N;%^!<%/(B
                    SendData(SndBuf);                   // $BAw?.<B9T(B4100$B%P%$%H(B
                    break;
                default:                                // $B$I$l$G$b$J$$>l9g(B
                    break;
            }
        }
    }
}
/***************************************************
*  A/D$BJQ49%G!<%?<}=83d$j9~$_=hM}4X?t(B
*  8$B2sJQ49$4$H$K3d$j9~$_@8@.!!%@%V%k%P%C%U%!(B
***************************************************/
#pragma interrupt AD1Interrupt ipl6 vector 23
void AD1Interrupt(void){
    LATBbits.LATB7 = 1;
    /* $B7WB,%G!<%?$r%P%C%U%!$X3JG<(B 2000$B8D(B */
    if(AD1CON2bits.BUFS == 1){              // $B;HMQCf%P%C%U%!%A%'%C%/(B
        Buffer[Index++] = ADC1BUF0;         // $B2<0L%P%C%U%!$N>l9g(B
        Buffer[Index++] = ADC1BUF1;
        Buffer[Index++] = ADC1BUF2;         // 8$B8D3JG<(B
        Buffer[Index++] = ADC1BUF3;
        Buffer[Index++] = ADC1BUF4;
        Buffer[Index++] = ADC1BUF5;
        Buffer[Index++] = ADC1BUF6;
        Buffer[Index++] = ADC1BUF7;
    }
    else{
        Buffer[Index++] = ADC1BUF8;         // $B>e0L%P%C%U%!$N>l9g(B
        Buffer[Index++] = ADC1BUF9;
        Buffer[Index++] = ADC1BUFA;
        Buffer[Index++] = ADC1BUFB;         // 8$B8D3JG<(B
        Buffer[Index++] = ADC1BUFC;
        Buffer[Index++] = ADC1BUFD;
        Buffer[Index++] = ADC1BUFE;
        Buffer[Index++] = ADC1BUFF;
    }
    if(Index >= 2000){                      // 2000$B2sJQ4940N;$+!)(B
        T3CONbits.TON = 0;                  // $B%?%$%^#3Dd;_(B
        BusyFlag = 0;                       // $BJQ49=*N;BT$A%U%i%02r=|(B
        Index = 0;                          // $B%P%C%U%!%$%s%G%C%/%9=i4|2=(B
    }
    IFS0bits.AD1IF = 0;                     // $B3d$j9~$_%U%i%0%/%j%"(B
    LATBbits.LATB7 = 0;
}
/***************************************************
* $B?eJ?F14|@Z$jBX$(!!%?%$%^#3$N<~4|JQ99(B
*  PR3 25nsec$BC10L$G@_Dj(B
***************************************************/
void Hsync(unsigned char num){
    switch(num){
        case 0:                 // 0.1usec$B"*(B10usec/div
        case 1:                 // 0.2usec$B"*(B20usec/div
        case 2:                 // 1usec$B!!"*(B100us/div
            PR3 = 39;		// 40MHz/40=1usec
            break;
        case 3:
            PR3 = 79;		// 2usec$B!!(B $B"*(B200us/div
            break;
        case 4:
            PR3 = 399;          // 10usec$B!!"*(B1msec/div
            break;
        case 5:
            PR3 = 1999;		// 50usec$B!!"*(B5msec/div
            break;
        default:                // $B$I$l$G$b$J$$>l9gJQ99$J$7(B
            break;
    }
}
/****************************************************
*  UART$B<u?.3d$j9~$_=hM}(B
*  64$BJ8;z$^$G<u?.$7%P%C%U%!$K3JG<(B
****************************************************/
#pragma interrupt U2RXHandler ipl4 vector 37
void U2RXHandler(void){
    char  data;

    /* $B<u?.%(%i!<%A%'%C%/(B */
    if(U2STAbits.OERR || U2STAbits.FERR) {
        data = U2RXREG;
        U1STA &= 0xFFF0;                    // $B%(%i!<%U%i%0%/%j%"(B
        U1MODE = 0;                         // UART1$BDd;_(B
        U2MODE = 0x00008800;
        U2STA  = 0x0000D400;
        Index = 0;
    }
    else {                                  // $B@5>o<u?.$N>l9g(B
        if(Index<64){                       // 64$B%P%$%H0J2<$N>l9g(B
            RcvBuf[Index++] = U2RXREG;      // $B%G!<%?<h$j=P$7(B
            if(Index >= 64){                // 64$B%P%$%H=*N;$+(B
                Flag = 1;                   // $B<u?.40N;%U%i%0%*%s(B
                Index = 0;                  // $B%]%$%s%?%j%;%C%H(B
            }
        }
        else                                // $B%P%C%U%!%*!<%P!<$N>l9g(B
            data = U2RXREG;                 // $BFI$_Ht$P$7$FL5;k(B
    }
    IFS1bits.U2RXIF = 0;                    // $B3d$j9~$_%U%i%0%/%j%"(B
}
 /********************************
 * UART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char Data){
    while(!U2STAbits.TRMT);                 // $BAw?.%l%G%#!<BT$A(B
    U2TXREG = Data;                         // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendData(unsigned char * buf)
{
    int i;
    for(i= 0; i<Max_Size; i++)              // 4100$B%P%$%H0l3gAw?.(B
        Send(*buf++);                       // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(unsigned char *cmd)
{
    while(*cmd != 0)                        // $B=*C<$^$G7+$jJV$7Aw?.(B
        Send(*cmd++);                       // $BAw?.<B9T(B
    Delayms(1000);                          // $BJV?.%9%-%C%WMQCY1d(B
}
/**********************************
*  $B%k!<%WCY1d4X?t!!(Busec$BC10L(B
**********************************/
void delay_us(unsigned int usec)
{
    unsigned int i, Max;

    Max = usec * 640/Fosc;
    for(i=0; i<Max; i++)
    {	}
}

/***********************************************
* $B%?%$%^(B2$B$K$h$k(B1msec$BC10L$NCY1d4X?t(B Tcy=40MHz
***********************************************/
void Delayms( unsigned int t){
    IFS0bits.T2IF = 0;                  // $B3d$j9~$_%U%i%0%/%j%"(B
    PR2 = 5000;                         // 1msec$B@_Dj(B
    T2CON = 0x8030;                     // $B%?%$%^(B2$B%9%?!<%H!!(B1/8
    while (t--) {                       // $B7+$jJV$72s?t(B
        while (!IFS0bits.T2IF);         // 1msec$BBT$A(B
        IFS0bits.T2IF = 0;              // $B3d$j9~$_%U%i%0%/%j%"(B
    }
}

